--[[-----------------------------------------------------------------------------
 Olivier Cthun, RU Guild, LUMEN
 Based on: https://github.com/goffauxs/Salad_Cthun
-------------------------------------------------------------------------------]]

local dotPos = {
    [1] = { -31, 54 }, --melee        	--
    [2] = { -21, 60 }, --2nd melee   	-|
    [3] = { -57, 81 }, --ranged    		-|Group 1
    [4] = { -17, 98 }, --ranged     	-|
    [5] = { -48, 116 }, --healer        --

    [6] = { 21, 60 }, -- melee      	--
    [7] = { 31, 54 }, --2nd melee       -|
    [8] = { 17, 98 }, --ranged    		-|Group 2
    [9] = { 57, 81 }, --ranged    		-|
    [10] = { 48, 116 }, --healer        --

    [11] = { -63, 15 }, -- melee    	--
    [12] = { -57, 24 }, --2nd melee   	-|
    [13] = { -99, 14 }, --ranged  		-|Group 3
    [14] = { -83, 53 }, --ranged   		-|
    [15] = { -118, 44 }, --healer       --

    [16] = { 57, 24 }, -- melee    		--
    [17] = { 62, 15 }, --2nd melee   	-|
    [18] = { 82, 53 }, --ranged    		-|Group 4
    [19] = { 98, 14 }, --ranged   		-|
    [20] = { 117, 44 }, --healer        --

    [21] = { -52, -30 }, -- melee     	--
    [22] = { -57, -20 }, --2nd melee   	-|
    [23] = { -79, -58 }, --ranged  		-|Group 5
    [24] = { -96, -20 }, --ranged   	-|
    [25] = { -114, -52 }, --healer      --

    [26] = { 61, -24 }, -- melee    	--
    [27] = { 55, -34 }, --2nd melee   	-|
    [28] = { 96, -20 }, --ranged  		-|Group 6
    [29] = { 79, -58 }, --ranged  		-|
    [30] = { 113, -52 }, --healer       --

    [31] = { -19, -63 }, -- melee   	--
    [32] = { -29, -58 }, --2nd melee  	-|
    [33] = { -15, -97 }, --ranged 		-|Group 7
    [34] = { -54, -81 }, --ranged 	    -|
    [35] = { -44, -117 }, --healer      --

    [36] = { 30, -55 }, -- melee     	--
    [37] = { 20, -60 }, --2nd melee   	-|
    [38] = { 54, -81 }, --ranged   		-|Group 8
    [39] = { 15, -97 }, --ranged  		-|
    [40] = { 44, -117 } --healer        --
}

local CLASS_COLOR = {
    ["WARRIOR"] = { 0.68, 0.51, 0.33 },
    ["ROGUE"] = { 1.0, 0.96, 0.31 },
    ["MAGE"] = { 0.21, 0.60, 0.74 },
    ["WARLOCK"] = { 0.48, 0.41, 0.69 },
    ["HUNTER"] = { 0.47, 0.73, 0.25 },
    ["PRIEST"] = { 1.0, 1.00, 1.00 },
    ["PALADIN"] = { 0.96, 0.55, 0.73 },
    ["DRUID"] = { 1.0, 0.49, 0.04 },
    ["SHAMAN"] = { 0.0, 0.34, 0.77 }
}

local oliPlayerName, _ = UnitName("player")

local FRAME_NAME = 'Olivier_UI'

local BACKDROP_SIZE = 512
local BORDER_SIZE = 12

local Olivier_Frame = CreateFrame("Frame", FRAME_NAME, UIParent)
Olivier_Frame:SetFrameStrata("HIGH")
Olivier_Frame:SetPoint("CENTER", 0, 0)
Olivier_Frame:SetHeight(BACKDROP_SIZE + BORDER_SIZE)
Olivier_Frame:SetWidth(BACKDROP_SIZE + BORDER_SIZE)
Olivier_Frame:EnableMouse(true)
Olivier_Frame:SetMovable(true)
Olivier_Frame:SetBackdrop({
    bgFile = "Interface\\AddOns\\OlivierCthun\\Media\\back.tga",
    edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border",
    tile = false,
    edgeSize = 32,
    insets = {
        left = BORDER_SIZE,
        right = BORDER_SIZE,
        top = BORDER_SIZE,
        bottom = BORDER_SIZE
    }
})

Olivier_Frame:SetScript("OnMouseWheel", function()
    local scale = (Olivier_Frame:GetScale() == 1) and 0.5 or 1
    Olivier_Frame:SetScale(scale)
end)

Olivier_Frame:RegisterEvent("GROUP_ROSTER_UPDATE")
Olivier_Frame:SetScript("OnEvent", function(self, event, ...)
    oliFill()
end)

tinsert(UISpecialFrames, FRAME_NAME); -- ESC
Olivier_Frame:Hide()

local Olivier_Header = CreateFrame("Frame", nil, Olivier_Frame)
Olivier_Header:SetPoint("TOP", Olivier_Frame, "TOP", -3, 12)
Olivier_Header:SetWidth(312)
Olivier_Header:SetHeight(64)
Olivier_Header:EnableMouse(true)
Olivier_Header:SetBackdrop({
    bgFile = "Interface\\DialogFrame\\UI-DialogBox-Header"
})
Olivier_Header:SetScript("OnMouseDown", function()
    Olivier_Frame:StartMoving()
end)
Olivier_Header:SetScript("OnMouseUp", function()
    Olivier_Frame:StopMovingOrSizing()
end)
Olivier_Header:SetScript("OnHide", function()
    Olivier_Frame:StopMovingOrSizing()
end)

local Olivier_Font = Olivier_Header:CreateFontString(nil, "OVERLAY", "GameFontHighlight")
Olivier_Font:SetPoint("CENTER", Olivier_Header, "CENTER", 0, 12)
Olivier_Font:SetText("Оливьешка (К'Тун)")

local Olivier_Exit = CreateFrame("Button", "Olivier_Exit", Olivier_Frame)
Olivier_Exit:SetPoint("TOPRIGHT", Olivier_Frame, "TOPRIGHT", -5, -5)
Olivier_Exit:SetHeight(32)
Olivier_Exit:SetWidth(32)
Olivier_Exit:SetNormalTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Up")
Olivier_Exit:SetHighlightTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Highlight")
Olivier_Exit:SetPushedTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Down")
Olivier_Exit:SetScript("OnLoad",
        function()
            Olivier_Exit:RegisterForClicks("AnyUp")
        end
)
Olivier_Exit:SetScript("OnClick",
        function()
            Olivier_Frame:Hide();
        end
)

--Create 40 dot frames
for i = 1, MAX_RAID_MEMBERS do
    dot = CreateFrame("Button", "Dot_" .. i, Olivier_Frame)
    dot:SetPoint("CENTER", Olivier_Frame, "CENTER", dotPos[i][1], dotPos[i][2])
    dot:EnableMouse(true)
    dot:SetFrameLevel(dot:GetFrameLevel() + 3)
    tooltip = CreateFrame("GameTooltip", "Tooltip_" .. i, nil, "GameTooltipTemplate")
    local texdot = dot:CreateTexture("Texture_" .. i, "OVERLAY")
    dot.texture = texdot
    texdot:SetAllPoints(dot)
    texdot:SetTexture("Interface\\AddOns\\OlivierCthun\\Media\\oliDot.tga")
    texdot:Hide()
    dot:SetScript("OnEnter", function()
        tooltip:SetOwner(dot, "ANCHOR_RIGHT")
        tooltip:SetText("Empty")
        tooltip:Show()
    end)
    dot:SetScript("OnLeave", function()
        tooltip:Hide()
    end)
end

local function newDot(dot, tooltip, texture, name, class)
    local size = (oliPlayerName == name) and 36 or 20
    dot:SetWidth(size)
    dot:SetHeight(size)
    dot:SetFrameLevel(size) -- first melee on top fix

    if name ~= "Empty" then
        texture:SetVertexColor(CLASS_COLOR[class][1], CLASS_COLOR[class][2], CLASS_COLOR[class][3], 1.0)
        texture:Show()
    else
        texture:Hide()
    end

    dot:SetScript("OnEnter", function()
        tooltip:SetOwner(dot, "ANCHOR_RIGHT")
        tooltip:SetText(name)
        tooltip:Show()
    end)

    dot:SetScript("OnLeave", function()
        tooltip:Hide()
    end)
end

local dotRes = { { { "Empty", "Empty" }, { "Empty", "Empty" }, { "Empty", "Empty" }, { "Empty", "Empty" }, { "Empty", "Empty" } }, -- group 1
                 { { "Empty", "Empty" }, { "Empty", "Empty" }, { "Empty", "Empty" }, { "Empty", "Empty" }, { "Empty", "Empty" } }, -- group 2
                 { { "Empty", "Empty" }, { "Empty", "Empty" }, { "Empty", "Empty" }, { "Empty", "Empty" }, { "Empty", "Empty" } }, --    |
                 { { "Empty", "Empty" }, { "Empty", "Empty" }, { "Empty", "Empty" }, { "Empty", "Empty" }, { "Empty", "Empty" } }, --    |
                 { { "Empty", "Empty" }, { "Empty", "Empty" }, { "Empty", "Empty" }, { "Empty", "Empty" }, { "Empty", "Empty" } }, --    |
                 { { "Empty", "Empty" }, { "Empty", "Empty" }, { "Empty", "Empty" }, { "Empty", "Empty" }, { "Empty", "Empty" } }, --    |
                 { { "Empty", "Empty" }, { "Empty", "Empty" }, { "Empty", "Empty" }, { "Empty", "Empty" }, { "Empty", "Empty" } }, --    |
                 { { "Empty", "Empty" }, { "Empty", "Empty" }, { "Empty", "Empty" }, { "Empty", "Empty" }, { "Empty", "Empty" } } } -- group 8



local function oliRaidInfo(debug)
    local rosterFunction = debug and oliFakeRaidRosterInfo or GetRaidRosterInfo
    for i = 1, MAX_RAID_MEMBERS do
        local name, _, group, _, _, class = rosterFunction(i);

        if (class == "ROGUE" or class == "WARRIOR") then
            if dotRes[group][1][1] == "Empty" or dotRes[group][1][1] == name then
                dotRes[group][1] = { name, class }
            elseif dotRes[group][2][1] == "Empty" or dotRes[group][2][1] == name then
                dotRes[group][2] = { name, class }
            elseif dotRes[group][3][1] == "Empty" or dotRes[group][3][1] == name then
                dotRes[group][3] = { name, class }
            elseif dotRes[group][4][1] == "Empty" or dotRes[group][4][1] == name then
                dotRes[group][4] = { name, class }
            else
                dotRes[group][5] = { name, class }
            end
        elseif (class == "MAGE" or class == "WARLOCK" or class == "HUNTER") then
            if dotRes[group][3][1] == "Empty" or dotRes[group][3][1] == name then
                dotRes[group][3] = { name, class }
            elseif dotRes[group][4][1] == "Empty" or dotRes[group][4][1] == name then
                dotRes[group][4] = { name, class }
            elseif dotRes[group][5][1] == "Empty" or dotRes[group][5][1] == name then
                dotRes[group][5] = { name, class }
            elseif dotRes[group][2][1] == "Empty" or dotRes[group][2][1] == name then
                dotRes[group][2] = { name, class }
            else
                dotRes[group][1] = { name, class }
            end
        elseif (class == "PRIEST" or class == "PALADIN" or class == "DRUID" or class == "SHAMAN") then
            if dotRes[group][5][1] == "Empty" or dotRes[group][5][1] == name then
                dotRes[group][5] = { name, class }
            elseif dotRes[group][4][1] == "Empty" or dotRes[group][4][1] == name then
                dotRes[group][4] = { name, class }
            elseif dotRes[group][3][1] == "Empty" or dotRes[group][3][1] == name then
                dotRes[group][3] = { name, class }
            elseif dotRes[group][2][1] == "Empty" or dotRes[group][2][1] == name then
                dotRes[group][2] = { name, class }
            else
                dotRes[group][1] = { name, class }
            end
        end
    end
end

function oliWipe()
    for i = 1, 8 do
        for j = 1, 5 do
            for k = 1, 2 do
                dotRes[i][j][k] = "Empty"
            end
        end
    end
end

function oliFill(debug)
    oliWipe()
    oliRaidInfo(debug)
    for i = 1, 8 do
        for j = 1, 5 do
            local x = ((i - 1) * 5) + j
            newDot(_G["Dot_" .. x], _G["Tooltip_" .. x], _G["Texture_" .. x], dotRes[i][j][1], dotRes[i][j][2])
        end
    end
end

local function oliSetMarks()
    for i = 1, MAX_RAID_MEMBERS do
        local name, _, _, _, _, _ = GetRaidRosterInfo(i);
        if (name) then
            SetRaidTarget(name, 0)
        end
    end
    for i = 0, 7 do
        if (dotRes[i + 1][1][1] ~= 'Empty') then
            SetRaidTarget(dotRes[i + 1][1][1], 8 - i)
        elseif (dotRes[i + 1][2][1] ~= 'Empty') then
            SetRaidTarget(dotRes[i + 1][2][1], 8 - i)
        elseif (dotRes[i + 1][3][1] ~= 'Empty') then
            SetRaidTarget(dotRes[i + 1][3][1], 8 - i)
        elseif (dotRes[i + 1][4][1] ~= 'Empty') then
            SetRaidTarget(dotRes[i + 1][4][1], 8 - i)
        elseif (dotRes[i + 1][5][1] ~= 'Empty') then
            SetRaidTarget(dotRes[i + 1][5][1], 8 - i)
        end
    end
end

local Olivier_Center = CreateFrame("Frame", "OLI_CENTER", Olivier_Frame)
Olivier_Center:SetPoint("CENTER", Olivier_Frame, "CENTER", 0, 0)
Olivier_Center:SetHeight(128)
Olivier_Center:SetWidth(128)
Olivier_Center:SetBackdrop({
    bgFile = "Interface\\AddOns\\OlivierCthun\\Media\\centerBordered.tga"
})

local Olivier_Marks = CreateFrame("Button", "Olivier_Marks", Olivier_Center)
Olivier_Marks:SetPoint("CENTER", Olivier_Frame, "CENTER", 0, 15)
Olivier_Marks:SetHeight(64)
Olivier_Marks:SetWidth(64)
Olivier_Marks:SetNormalTexture("Interface\\AddOns\\OlivierCthun\\Media\\oliCthunNormal.tga", 'DISABLE')
Olivier_Marks:SetHighlightTexture("Interface\\AddOns\\OlivierCthun\\Media\\oliCthunHighlight.tga", "MOD")
Olivier_Marks:SetPushedTexture("Interface\\AddOns\\OlivierCthun\\Media\\oliCthunPressed.tga", "BLEND")

Olivier_Marks:SetScript("OnLoad", function()
    Olivier_Marks:RegisterForClicks("AnyUp")
end)

Olivier_Marks:SetScript("OnClick", function()
    oliSetMarks()
end)

SLASH_CTHUN1 = '/cthun';
SLASH_CTHUN2 = '/ктун';
local function HandleSlashCommands(arg)
    if (arg == 'test' or arg == 'тест') then
        Olivier_Frame:Show();
        oliFill('debug')
    elseif (arg == 'reset' or arg == 'сброс') then
    	Olivier_Frame:ClearAllPoints()
    	Olivier_Frame:SetPoint("CENTER", 0, 0)
    elseif (arg == '' or arg == nil) then
        Olivier_Frame:Show();
        oliFill()
    else
        print("|cffffff00Use \'/cthun test\' to show fake raid");
    end
end

SlashCmdList.CTHUN = HandleSlashCommands;
